# Changelog
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html),
and is generated by [Changie](https://github.com/miniscruff/changie).



## sdk/go/v0.9.7 - 2024-01-19

This SDK uses 🚙 Engine + 🚗 CLI version `v0.9.7`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.9.7).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.9.7


### Dependencies
- Bump Engine to v0.9.7 by @github-actions in https://github.com/dagger/dagger/pull/6460

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.9.6 - 2024-01-12

This SDK uses 🚙 Engine + 🚗 CLI version `v0.9.6`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.9.6).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.9.6


### Added
- Add a default global client at dagger.io/dagger/dag by @jedevc in https://github.com/dagger/dagger/pull/6326

### Dependencies
- Bump Engine to v0.9.6 by @github-actions in https://github.com/dagger/dagger/pull/6410

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.9.5 - 2023-12-21

This SDK uses 🚙 Engine + 🚗 CLI version `v0.9.5`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.9.5).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.9.5


### Dependencies
- Bump Engine to v0.9.5 by @github-actions in https://github.com/dagger/dagger/pull/6309

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.9.4 - 2023-12-08

This SDK uses 🚙 Engine + 🚗 CLI version `v0.9.4`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.9.4).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.9.4


### Dependencies
- Bump Engine to v0.9.4 by @github-actions in https://github.com/dagger/dagger/pull/6239

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.9.3 - 2023-11-03

This SDK uses 🚙 Engine + 🚗 CLI version `v0.9.3`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.9.3).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.9.3


### Dependencies
- Bump Engine to v0.9.3 by @github-actions in https://github.com/dagger/dagger/pull/6061

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.9.2 - 2023-10-30

This SDK uses 🚙 Engine + 🚗 CLI version `v0.9.2`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.9.2).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.9.2

### Dependencies

- Bump Engine to v0.9.2 by @github-actions in https://github.com/dagger/dagger/pull/6024

### What to do next

- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.9.1 - 2023-10-26

This SDK uses 🚙 Engine + 🚗 CLI version `v0.9.1`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.9.1).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.9.1


### Dependencies
- Bump Engine to v0.9.1 by @github-actions in https://github.com/dagger/dagger/pull/5969

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.9.0 - 2023-10-20

This SDK uses 🚙 Engine + 🚗 CLI version `v0.9.0`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.9.0).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.9.0

### 🔥 Breaking Changes

- engine: new services API with container <=> host networking, explicit start/stop by @vito in https://github.com/dagger/dagger/pull/5557
- implement new conventions for IDable objects by @vito in https://github.com/dagger/dagger/pull/5881

### Dependencies

- Bump Engine to v0.9.0 by @github-actions in https://github.com/dagger/dagger/pull/5940

### What to do next

- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.8.8 - 2023-10-11

This SDK uses 🚙 Engine + 🚗 CLI version `v0.8.8`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.8.8).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.8.8


### Dependencies
- Bump Engine to v0.8.8 by @github-actions in https://github.com/dagger/dagger/pull/5877

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.8.7 - 2023-09-18

This SDK uses 🚙 Engine + 🚗 CLI version `v0.8.7`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.8.7).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.8.7


### Dependencies
- Bump Engine to v0.8.7 by @github-actions in https://github.com/dagger/dagger/pull/5799

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.8.6 - 2023-09-18

This SDK uses 🚙 Engine + 🚗 CLI version `v0.8.6`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.8.6).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.8.6


### Fixed
- Check and panic if a nil pointer is sent as argument to a query by @TomChv in https://github.com/dagger/dagger/pull/5785

### Dependencies
- Bump Engine to v0.8.6 by @github-actions in https://github.com/dagger/dagger/pull/5795

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.8.5 - 2023-09-13

This SDK uses 🚙 Engine + 🚗 CLI version `v0.8.5`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.8.5).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.8.5


### Dependencies
- Bump Engine to v0.8.5 by @github-actions in https://github.com/dagger/dagger/pull/5779

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.8.4 - 2023-08-17

This SDK uses 🚙 Engine + 🚗 CLI version `v0.8.4`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.8.4).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.8.4


### Dependencies
- Bump Engine to v0.8.4 by @github-actions in https://github.com/dagger/dagger/pull/5657

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.8.3 - 2023-08-16

This SDK uses 🚙 Engine + 🚗 CLI version `v0.8.3`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.8.3).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.8.3


### Dependencies
- Bump Engine to v0.8.3 by @github-actions in https://github.com/dagger/dagger/pull/5643

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.8.2 - 2023-08-10

This SDK uses 🚙 Engine + 🚗 CLI version `v0.8.2`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.8.2).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.8.2


### Fixed
- Expand `~` to home when using custom CLI path by @wingyplus in https://github.com/dagger/dagger/pull/5555

### Dependencies
- Bump Engine to v0.8.2 by @github-actions in https://github.com/dagger/dagger/pull/5613

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.8.1 - 2023-08-04

This SDK uses 🚙 Engine + 🚗 CLI version `v0.8.1`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.8.1).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.8.1


### Dependencies
- Bump Engine to v0.8.1 by @github-actions in https://github.com/dagger/dagger/pull/5581

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.8.0 - 2023-08-03

This SDK uses 🚙 Engine + 🚗 CLI version `v0.8.0`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.8.0).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.8.0

### Added
- Print progress status during automatic Engine provisioning and establishing client connection by @TomChv in https://github.com/dagger/dagger/pull/5488
- Show warning on version mismatch between Engine and SDK by @TomChv in https://github.com/dagger/dagger/pull/5315

### Dependencies
- Bump Engine to v0.8.0 by @github-actions in https://github.com/dagger/dagger/pull/5567

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.7.4 - 2023-07-19

This SDK uses 🚙 Engine + 🚗 CLI version `v0.6.4`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.6.4).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.7.4

### Added
- Added the `With` method to more types by @helderco in https://github.com/dagger/dagger/pull/5447

### Dependencies
- Bump Engine to v0.6.4 by @github-actions in https://github.com/dagger/dagger/pull/5489

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)



## sdk/go/v0.7.3 - 2023-07-04

This SDK uses 🚙 Engine + 🚗 CLI version `v0.6.3`. [See what changed in that release](https://github.com/dagger/dagger/releases/tag/v0.6.3).

🐹 https://pkg.go.dev/dagger.io/dagger@v0.7.3

### Dependencies
- Bump Engine to v0.6.3 by @github-actions in https://github.com/dagger/dagger/pull/5407

### What to do next
- Read the [documentation](https://docs.dagger.io/sdk/go)
- Join our [Discord server](https://discord.gg/dagger-io)
- Follow us on [Twitter](https://twitter.com/dagger_io)
